//======================================================================
// ~VvbNX@ɂA֐̍œKT[`GW̃NX
// ~VvbNX@(Downhill simplex method)
// T@Nelder, J.A., and Mead, R.: Computer Journal, Vol.7, p.308 (1965).
//  j[JVsECEV[iZp]_Ёjpp.284
//u͂fɍ~A֐ɂĂ͂قƂǂǂȉȂB
// ͔ɒxAꍇɂĂ͔Ɋ挒łBAvO
// ȌŁASȏ[IłBm̍ŏvOPOOsȉ
// ̂łI̕@͓ɍŏŜ̒ɂ܂܊܂܂ꂽꕔ
// łƂɕ֗łBKvȋLʂN^2̃I[_[ł邪A
// ֐̌vZ͕svłBv
//                                                                     |
//  Copyright 2006 Hajime Kimura, Kyushu Univ.                         |
//  http://sysplan.nams.kyushu-u.ac.jp/gen/index.html
//======================================================================
import java.io.*;
// import FitnessFunction ;

public class DownHillSimplexMethod { 
	//-----------------------Ow肳p[^
	public int    param_dim;    // œKp[^xNg̎
	public int    numOfSmp;     // VvbNX̌
	public SMPINDV individual[] ; //	
	public int    xh  ;         // ֐lő̓_̃CfbNX
	public int    xs  ;         // ֐l2Ԗڂɑ傫_̃CfbNX
	public int    xl  ;         // ֐lŏ̓_̃CfbNX
	public SMPINDV point_xg  ;   // xh̓_SẴVvbNX̏dS
	public SMPINDV point_xr  ;   // xhxgŐ܂Ԃ˓_
	public SMPINDV point_xe  ;   // g_
	public SMPINDV point_xc  ;   // k_
	public FitnessFunction objectiveFunc   ;
	public static double alpha = 1.0 ;
	public static double beta  = 0.5 ;
	public static double gamma = 2.0 ;

	//RXgN^------------------------------------------------
	DownHillSimplexMethod( FitnessFunction InpFitnessFunction, int num_of_smp  ){ 
		//-------------------
		objectiveFunc = InpFitnessFunction ;
		objectiveFunc.Init() ;
		param_dim = objectiveFunc.GetParameterDimension() ;
		if( param_dim <  num_of_smp ){
			numOfSmp = num_of_smp;
		}else{
			numOfSmp = param_dim + 1;
		}
		individual = new SMPINDV[numOfSmp];
		for( int ai = 0; ai < numOfSmp ; ai++ ){
			individual[ai] = new SMPINDV( param_dim );
		}
		point_xg = new SMPINDV( param_dim );
		point_xr = new SMPINDV( param_dim );
		point_xe = new SMPINDV( param_dim );
		point_xc = new SMPINDV( param_dim );
	}
	//-----------------------------------------------------------------
	public int init(){
		int ai, bi;
		double band ;
		double tmp ;
		//----------VvbNXE]
		for( ai = 0; ai < numOfSmp ; ai++ ){
			for( bi = 0; bi < param_dim ; bi++ ){
				band =  objectiveFunc.GetParameterUpperBound(bi);
				band -= objectiveFunc.GetParameterLowerBound(bi);
				band *= Math.random();
				tmp = objectiveFunc.GetParameterLowerBound(bi);
				individual[ai].param[bi] = tmp + band;
			}
		}
		//-----------SẴVvbNX̕]s
		evaluateAllSimplexes();
		//-----------xh,xs, xl,xg߂
		findxhxsxlxg();
		//-----------
		return( 0 );
	}
	//-----------SẴVvbNX̕]s
	int evaluateAllSimplexes(){
		int ai ;
		//---------------
		for( ai = 0; ai < numOfSmp ; ai++ ){
			individual[ai].loss = objectiveFunc.evaluate(individual[ai].param);
		}
		return( 0 );
	}
	//-----------xh,xs, xl,xg߂
	int findxhxsxlxg(){
		int ai, bi;
		//----------
		xh = 0 ;         // ֐lő̓_̃CfbNX
		xl = 0 ;         // ֐lŏ̓_̃CfbNX
		double xh_loss = individual[xh].loss ;
		double xl_loss = individual[xl].loss ;
		//------őEŏ_߂
		for( ai = 0; ai < numOfSmp ; ai++ ){
			if( individual[ai].loss > xh_loss ){
				xh_loss =  individual[ai].loss ;
				xh = ai;
			}
			if( individual[ai].loss < xl_loss ){
				xl_loss =  individual[ai].loss ;
				xl = ai;
			}
		}
		//-------֐l2Ԗڂɑ傫_߂
		xs = 0 ;         // ֐l2Ԗڂɑ傫_̃CfbNX
		if( xh == 0 ){ xs = 1;}
		double xs_loss = individual[xs].loss ;
		for( ai = 0; ai < numOfSmp ; ai++ ){
			if( individual[ai].loss > xs_loss ){
				if( ai != xh ){
					xs_loss =  individual[ai].loss ;
					xs = ai;
				}
			}
		}
		//-------xgvZ
		for( bi = 0; bi < param_dim ; bi++ ){
			point_xg.param[bi] = 0.0 ;
			for( ai = 0; ai < numOfSmp ; ai++ ){
				if( ai != xh ){
					point_xg.param[bi] += individual[ai].param[bi] ;
				}
			}
			point_xg.param[bi] /= ((double)(numOfSmp -1)) ;
		}
		//---------xg̊֐l͕KvȂ
		// point_xg.loss = objectiveFunc.evaluate( point_xg.param );
		point_xg.loss = 0 ;
		//------------
		return( 0 );
	}	
	//--------------------
	int reflect() {
		//-------xrvZ
		for( int bi = 0; bi < param_dim ; bi++ ){
			point_xr.param[bi] =  (1.0 + alpha)*point_xg.param[bi] ;
			point_xr.param[bi] -= alpha * individual[xh].param[bi] ;
		}
		point_xr.loss = objectiveFunc.evaluate( point_xr.param );
		return( 0 );
	}
	int expand() {
		//-------xevZ
		for( int bi = 0; bi < param_dim ; bi++ ){
			point_xe.param[bi] =  gamma * point_xr.param[bi] ;
			point_xe.param[bi] += (1.0 - gamma) * point_xg.param[bi] ;
		}
		point_xe.loss = objectiveFunc.evaluate( point_xe.param );
		return( 0 );
	}
	int contract() { //--- k
		//-------xcvZ
		for( int bi = 0; bi < param_dim ; bi++ ){
			point_xc.param[bi] =  beta * individual[xh].param[bi] ;
			point_xc.param[bi] += (1.0 - beta) * point_xg.param[bi] ;
		}
		point_xc.loss = objectiveFunc.evaluate( point_xc.param );
		return( 0 );
	}
	int reduction() { //----- k
		int ai, bi;
		for( bi = 0; bi < param_dim ; bi++ ){
			point_xg.param[bi] = 0.0 ;
			for( ai = 0; ai < numOfSmp ; ai++ ){
				individual[ai].param[bi] += individual[xl].param[bi] ;
				individual[ai].param[bi] /= 2.0 ;
			}
		}
		//-----------SẴVvbNX̕]s
		evaluateAllSimplexes();
		return( 0 );
	}
	//=====================================
	double executeOneLoop(){
		int ai, bi;
		//-----------xh,xs, xl,xg߂
		findxhxsxlxg();
		//--(2)
		reflect();
		//--(4)
		if( point_xr.loss <= individual[xl].loss ){ // ˓_ŗǓ_ǂꍇ
			expand() ; // g
			if( point_xe.loss < point_xr.loss ){ // g_˓_ǂꍇ
				//---xh xeŒu
				for( bi = 0; bi < param_dim ; bi++ ){
					individual[xh].param[bi] = point_xe.param[bi] ;
				}
				individual[xh].loss = point_xe.loss ;
				return( individual[xl].loss );
			}else{ // if( point_xe.loss >= point_xr.loss ){
				// g_˓_Ăꍇ
				//---xh xrŒu
				for( bi = 0; bi < param_dim ; bi++ ){
					individual[xh].param[bi] = point_xr.param[bi] ;
				}
				individual[xh].loss = point_xr.loss ;
				return( individual[xh].loss );
			}
		}else if( (individual[xs].loss < point_xr.loss) ){ // ˓_QԖڂɈ_舫ꍇ
			//--(5),(6)
			if( point_xr.loss < individual[xh].loss ){ // ˓_͍ň_̓}Vȏꍇ
				//-----(5)xh  xrɒu
				for( bi = 0; bi < param_dim ; bi++ ){
					individual[xh].param[bi] = point_xr.param[bi] ;
				}
				individual[xh].loss = point_xr.loss ;
			} // (6)Ȃ xĥ܂܂ŒuȂ
			//----k (5),(6)
			contract();
			if( point_xc.loss < individual[xh].loss ){ // k_ň_ǂ
				//-----xh  xcɒu
				for( bi = 0; bi < param_dim ; bi++ ){
					individual[xh].param[bi] = point_xc.param[bi] ;
				}
				individual[xh].loss = point_xc.loss ;
				return( individual[xl].loss );
			}else{ // if(  individual[xh].loss <=  point_xc.loss ){
				//--k
				reduction(); // kł xl ͓Ȃ
				return( individual[xl].loss );
			}
		}else{
			//--(3)
			//-----xh  xrɒu
			for( bi = 0; bi < param_dim ; bi++ ){
				individual[xh].param[bi] = point_xr.param[bi] ;
			}
			individual[xh].loss = point_xr.loss ;
			return( individual[xl].loss );
		}
	}
	//----------------
	double [] getGoodParam(){
		return(  individual[xl].param );
	}
}

class SMPINDV {
	public double param[] ; // p[^̉
	public double loss    ; // Lp[^̕]l
	//RXgN^------------------------------------------------
	SMPINDV( int   inp_dim         // ԓ̓xNg̎
                 ){   
		param = new double[inp_dim] ;
		loss = 0.0 ;
	}
}


// [⑫]===========================================================
